VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Session lock/unlock tracker"
   ClientHeight    =   3660
   ClientLeft      =   45
   ClientTop       =   405
   ClientWidth     =   9225
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3660
   ScaleWidth      =   9225
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3180
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   8895
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements ISubclass

Private mfNeedsToUnregisterNotifications As Boolean

Private Sub Form_Load()
  SubclassWindowForNotifications Me, Me.hwnd
  mfNeedsToUnregisterNotifications = RegisterForSessionNotifications(Me.hwnd, NOTIFY_FOR_THIS_SESSION)
  If Not mfNeedsToUnregisterNotifications Then
    MsgBox "Can register for session notifications" & vbCrLf & vbCrLf & LastDllErrorMsg(), vbCritical
  End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If mfNeedsToUnregisterNotifications Then UnRegisterForSessionNotifications Me.hwnd
  UnsubclassWindowForNotifications Me.hwnd
End Sub

'Will receive only WM_WTSSESSION_CHANGE messages
Private Function ISubclass_WindowProc(ByVal plHwnd As Long, ByVal plMsg As Long, ByVal pwParam As Long, ByVal plParam As Long) As Long
  If plHwnd <> Me.hwnd Then Exit Function 'something would be really wrong then
  
  Dim sTimeStamp As String
  sTimeStamp = Format$(Now, "dd.mm.yyyy hh:mm:ss")
  
  Select Case pwParam
  Case WTS_SESSION_LOCK
    List1.AddItem sTimeStamp & " SESSION LOCKED"
  Case WTS_SESSION_UNLOCK
    List1.AddItem sTimeStamp & " SESSION UNLOCKED"
  End Select
End Function
